Subject: Re: bug#66782: 29.1; ERT tests report test redefined depending on loading sequence

From: Mattias Engdegård <[email-masked]>
Date: Sat, 28 Oct 2023 14:46:23 +0200

28 okt. 2023 kl. 14.03 skrev Eli Zaretskii <[email-masked]>:

> We could reasonably expect from the author of a single .el test file
> to make sure the tests in that file don't interfere with one another
> and make the necessary cleanups for that purpose.  But it is much
> harder to expect the same from several disparate test files, which can
> quite frequently be written and maintained by different people.

I agree, and I have found this to be far from uncommon in practice.

Treating redefined test cases as errors found and still finds serious testing bugs, so we definitely want to keep the check as it is or in some equivalent form (a warning wouldn't be nearly as good).

And I also agree that the way this test runner explicitly loads .el files without any concern for whether they logically represent a single test collection or are just sub-modules for use in other tests, is quite questionable. 

I may be missing the point entirely, but what about using a file name convention like Emacs, where only *-tests.el are considered to be actual tests?